from datetime import date

from pydantic import BaseModel, Field

from .normalized import NormalizedRecordTypes


class DataQueueMsg(BaseModel, anystr_strip_whitespace=True, min_anystr_length=1):
    record: NormalizedRecordTypes = Field(..., discriminator="record_type")
    client: str
    data_date: date
    run_id: str

    @property
    def group_id(self) -> str:
        return "-".join([self.client, str(self.record.facility_id)])
